# Snapshot

Operations to create and manage point in time snapshots for your In-Memory DB replica sets.

This tag groups all operations for snapshot.

## Retrieve all Snapshot

> This endpoint enables retrieving all Snapshot using\
> pagination and optional filters.<br>

```json
{"openapi":"3.0.3","info":{"title":"In-Memory DB API","version":"1.0.0"},"tags":[{"name":"Snapshot","description":"Operations to create and manage point in time snapshots for your In-Memory DB replica sets.\n\nThis tag groups all operations for snapshot.\n"}],"servers":[{"url":"https://in-memory-db.de-fra.ionos.com","description":"service endpoint for location de-fra"},{"url":"https://in-memory-db.de-txl.ionos.com","description":"service endpoint for location de-txl"},{"url":"https://in-memory-db.es-vit.ionos.com","description":"service endpoint for location es-vit"},{"url":"https://in-memory-db.gb-bhx.ionos.com","description":"service endpoint for location gb-bhx"},{"url":"https://in-memory-db.gb-lhr.ionos.com","description":"service endpoint for location gb-lhr"},{"url":"https://in-memory-db.us-ewr.ionos.com","description":"service endpoint for location us-ewr"},{"url":"https://in-memory-db.us-las.ionos.com","description":"service endpoint for location us-las"},{"url":"https://in-memory-db.us-mci.ionos.com","description":"service endpoint for location us-mci"},{"url":"https://in-memory-db.fr-par.ionos.com","description":"service endpoint for location fr-par"}],"security":[{"tokenAuth":[]}],"components":{"securitySchemes":{"tokenAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT","description":"The token can be generated using the \n[Authentication API](https://api.ionos.com/docs/authentication/v1/#tag/tokens/operation/tokensGenerate).\n"}},"parameters":{"paginationOffset":{"name":"offset","in":"query","description":"The first element (of the total list of elements) to include in the response. Use this parameter together with the limit for pagination.","required":false,"schema":{"type":"integer","format":"int32","default":0,"minimum":0}},"paginationLimit":{"name":"limit","in":"query","description":"The maximum number of elements to return. Use this parameter together with the offset for pagination.","required":false,"schema":{"type":"integer","format":"int32","default":100,"minimum":1,"maximum":1000}}},"schemas":{"SnapshotReadList":{"allOf":[{"type":"object","required":["id","type","href"],"properties":{"id":{"description":"ID of the list of Snapshot resources.","type":"string","format":"uuid"},"type":{"description":"The type of the resource.","type":"string","enum":["collection"]},"href":{"description":"The URL of the list of Snapshot resources.","type":"string"},"items":{"description":"The list of Snapshot resources.","type":"array","items":{"$ref":"#/components/schemas/SnapshotRead"}}}},{"$ref":"#/components/schemas/Pagination"}]},"SnapshotRead":{"type":"object","required":["id","type","href","metadata","properties"],"properties":{"id":{"type":"string","description":"The ID (UUID) of the Snapshot.","format":"uuid"},"type":{"description":"The type of the resource.","type":"string","enum":["snapshot"]},"href":{"description":"The URL of the Snapshot.","type":"string"},"metadata":{"$ref":"#/components/schemas/SnapshotMetadata"},"properties":{"$ref":"#/components/schemas/Snapshot"}}},"SnapshotMetadata":{"readOnly":true,"allOf":[{"$ref":"#/components/schemas/Metadata"},{"$ref":"#/components/schemas/ResourceState"},{"type":"object","required":["replicasetId","datacenterId"],"properties":{"replicasetId":{"type":"string","format":"uuid","description":"The ID of the In-Memory DB replica set the snapshot is taken from.\n"},"snapshotTime":{"type":"string","format":"date-time","description":"The time the snapshot was dumped from the replica set."},"datacenterId":{"type":"string","format":"uuid","description":"The ID of the datacenter the snapshot was created in.\nPlease mind, that the snapshot is not available in other datacenters.\n"}}}]},"Metadata":{"type":"object","description":"Metadata of the resource.","properties":{"createdDate":{"type":"string","format":"date-time","description":"The ISO 8601 creation timestamp.","readOnly":true},"createdBy":{"type":"string","description":"Unique name of the identity that created the resource.","readOnly":true},"createdByUserId":{"type":"string","description":"Unique id of the identity that created the resource.","readOnly":true},"lastModifiedDate":{"type":"string","format":"date-time","description":"The ISO 8601 modified timestamp.","readOnly":true},"lastModifiedBy":{"type":"string","description":"Unique name of the identity that last modified the resource.","readOnly":true},"lastModifiedByUserId":{"type":"string","description":"Unique id of the identity that last modified the resource.","readOnly":true},"resourceURN":{"type":"string","description":"Unique name of the resource.","readOnly":true}}},"ResourceState":{"type":"object","description":"The current status of the resource.","required":["state"],"properties":{"state":{"type":"string","enum":["AVAILABLE","BUSY","FAILED","UNKNOWN"]},"message":{"type":"string","description":"A human readable message describing the current state.\nIn case of an error, the message will contain a detailed error message.\n"}}},"Snapshot":{"description":"A point in time snapshot of a In-Memory DB replica set.\n","type":"object"},"Pagination":{"required":["offset","limit","_links"],"description":"Pagination information. The offset and limit parameters are used to\nnavigate the list of elements. The _links object contains URLs to\nnavigate the different pages.\n","type":"object","properties":{"offset":{"$ref":"#/components/schemas/Offset"},"limit":{"$ref":"#/components/schemas/Limit"},"_links":{"$ref":"#/components/schemas/Links"}}},"Offset":{"description":"The offset specified in the request (if none was specified, the default\noffset is 0).\n","type":"integer","minimum":0,"readOnly":true},"Limit":{"description":"The limit specified in the request (if none was specified, use the\nendpoint's default pagination limit).\n","type":"integer","minimum":0,"readOnly":true},"Links":{"description":"URLs to navigate the different pages. As of now we always only return a\nsingle page.\n","type":"object","properties":{"prev":{"description":"URL (with offset and limit parameters) of the previous page; only\npresent if offset is greater than 0.\n","type":"string","format":"uri","readOnly":true},"self":{"description":"URL (with offset and limit parameters) of the current page.\n","type":"string","format":"uri","readOnly":true},"next":{"description":"URL (with offset and limit parameters) of the next page; only\npresent if offset + limit is less than the total number of elements.\n","type":"string","format":"uri","readOnly":true}}},"Error":{"description":"The Error object is used to represent an error response from the API.\n","type":"object","properties":{"httpStatus":{"type":"integer","description":"The HTTP status code of the operation."},"messages":{"type":"array","description":"A list of error messages.\n","items":{"type":"object","properties":{"errorCode":{"type":"string","description":"Application internal error code\n"},"message":{"type":"string","description":"A human readable explanation specific to this occurrence of the\nproblem.\n"}}}}}}},"responses":{"BadRequest":{"description":"### Bad Request\nThe request send to the API was malformed.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"Unauthorized":{"description":"### Unauthorized\nThe request is missing authorization information or the authorization information provided are expired.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotAllowed":{"description":"### Not Allowed\nThe user issuing the request does not have the needed permissions.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"TooManyRequests":{"description":"### Too Many Requests\nThe user has sent too many requests in a given amount of time.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"InternalError":{"description":"### Internal Server Error\nAn internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"ServiceUnavailable":{"description":"### Service Unavailable\nThe server is currently unable to handle the request due to a temporary overloading or maintenance of the server.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnexpectedError":{"description":"### Unexpected Internal Server Error\nAn unexpected internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}},"paths":{"/snapshots":{"get":{"operationId":"snapshotsGet","summary":"Retrieve all Snapshot","description":"This endpoint enables retrieving all Snapshot using\npagination and optional filters.\n","parameters":[{"$ref":"#/components/parameters/paginationOffset"},{"$ref":"#/components/parameters/paginationLimit"}],"tags":["Snapshot"],"responses":{"200":{"description":"Returned all requested Snapshot successfully.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/SnapshotReadList"}}}},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/NotAllowed"},"429":{"$ref":"#/components/responses/TooManyRequests"},"500":{"$ref":"#/components/responses/InternalError"},"503":{"$ref":"#/components/responses/ServiceUnavailable"},"default":{"$ref":"#/components/responses/UnexpectedError"}}}}}}
```

## Retrieve Snapshot

> Returns the Snapshot by ID.

```json
{"openapi":"3.0.3","info":{"title":"In-Memory DB API","version":"1.0.0"},"tags":[{"name":"Snapshot","description":"Operations to create and manage point in time snapshots for your In-Memory DB replica sets.\n\nThis tag groups all operations for snapshot.\n"}],"servers":[{"url":"https://in-memory-db.de-fra.ionos.com","description":"service endpoint for location de-fra"},{"url":"https://in-memory-db.de-txl.ionos.com","description":"service endpoint for location de-txl"},{"url":"https://in-memory-db.es-vit.ionos.com","description":"service endpoint for location es-vit"},{"url":"https://in-memory-db.gb-bhx.ionos.com","description":"service endpoint for location gb-bhx"},{"url":"https://in-memory-db.gb-lhr.ionos.com","description":"service endpoint for location gb-lhr"},{"url":"https://in-memory-db.us-ewr.ionos.com","description":"service endpoint for location us-ewr"},{"url":"https://in-memory-db.us-las.ionos.com","description":"service endpoint for location us-las"},{"url":"https://in-memory-db.us-mci.ionos.com","description":"service endpoint for location us-mci"},{"url":"https://in-memory-db.fr-par.ionos.com","description":"service endpoint for location fr-par"}],"security":[{"tokenAuth":[]}],"components":{"securitySchemes":{"tokenAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT","description":"The token can be generated using the \n[Authentication API](https://api.ionos.com/docs/authentication/v1/#tag/tokens/operation/tokensGenerate).\n"}},"schemas":{"SnapshotRead":{"type":"object","required":["id","type","href","metadata","properties"],"properties":{"id":{"type":"string","description":"The ID (UUID) of the Snapshot.","format":"uuid"},"type":{"description":"The type of the resource.","type":"string","enum":["snapshot"]},"href":{"description":"The URL of the Snapshot.","type":"string"},"metadata":{"$ref":"#/components/schemas/SnapshotMetadata"},"properties":{"$ref":"#/components/schemas/Snapshot"}}},"SnapshotMetadata":{"readOnly":true,"allOf":[{"$ref":"#/components/schemas/Metadata"},{"$ref":"#/components/schemas/ResourceState"},{"type":"object","required":["replicasetId","datacenterId"],"properties":{"replicasetId":{"type":"string","format":"uuid","description":"The ID of the In-Memory DB replica set the snapshot is taken from.\n"},"snapshotTime":{"type":"string","format":"date-time","description":"The time the snapshot was dumped from the replica set."},"datacenterId":{"type":"string","format":"uuid","description":"The ID of the datacenter the snapshot was created in.\nPlease mind, that the snapshot is not available in other datacenters.\n"}}}]},"Metadata":{"type":"object","description":"Metadata of the resource.","properties":{"createdDate":{"type":"string","format":"date-time","description":"The ISO 8601 creation timestamp.","readOnly":true},"createdBy":{"type":"string","description":"Unique name of the identity that created the resource.","readOnly":true},"createdByUserId":{"type":"string","description":"Unique id of the identity that created the resource.","readOnly":true},"lastModifiedDate":{"type":"string","format":"date-time","description":"The ISO 8601 modified timestamp.","readOnly":true},"lastModifiedBy":{"type":"string","description":"Unique name of the identity that last modified the resource.","readOnly":true},"lastModifiedByUserId":{"type":"string","description":"Unique id of the identity that last modified the resource.","readOnly":true},"resourceURN":{"type":"string","description":"Unique name of the resource.","readOnly":true}}},"ResourceState":{"type":"object","description":"The current status of the resource.","required":["state"],"properties":{"state":{"type":"string","enum":["AVAILABLE","BUSY","FAILED","UNKNOWN"]},"message":{"type":"string","description":"A human readable message describing the current state.\nIn case of an error, the message will contain a detailed error message.\n"}}},"Snapshot":{"description":"A point in time snapshot of a In-Memory DB replica set.\n","type":"object"},"Error":{"description":"The Error object is used to represent an error response from the API.\n","type":"object","properties":{"httpStatus":{"type":"integer","description":"The HTTP status code of the operation."},"messages":{"type":"array","description":"A list of error messages.\n","items":{"type":"object","properties":{"errorCode":{"type":"string","description":"Application internal error code\n"},"message":{"type":"string","description":"A human readable explanation specific to this occurrence of the\nproblem.\n"}}}}}}},"responses":{"BadRequest":{"description":"### Bad Request\nThe request send to the API was malformed.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"Unauthorized":{"description":"### Unauthorized\nThe request is missing authorization information or the authorization information provided are expired.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotAllowed":{"description":"### Not Allowed\nThe user issuing the request does not have the needed permissions.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotFound":{"description":"### Not Found\nThe resource that was requested could not be found.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"TooManyRequests":{"description":"### Too Many Requests\nThe user has sent too many requests in a given amount of time.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"InternalError":{"description":"### Internal Server Error\nAn internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"ServiceUnavailable":{"description":"### Service Unavailable\nThe server is currently unable to handle the request due to a temporary overloading or maintenance of the server.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnexpectedError":{"description":"### Unexpected Internal Server Error\nAn unexpected internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}},"paths":{"/snapshots/{snapshotId}":{"get":{"operationId":"snapshotsFindById","summary":"Retrieve Snapshot","tags":["Snapshot"],"description":"Returns the Snapshot by ID.","parameters":[{"name":"snapshotId","in":"path","schema":{"type":"string","format":"uuid"},"required":true,"description":"The ID (UUID) of the Snapshot."}],"responses":{"200":{"description":"Getting Snapshot was successful.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/SnapshotRead"}}}},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/NotAllowed"},"404":{"$ref":"#/components/responses/NotFound"},"429":{"$ref":"#/components/responses/TooManyRequests"},"500":{"$ref":"#/components/responses/InternalError"},"503":{"$ref":"#/components/responses/ServiceUnavailable"},"default":{"$ref":"#/components/responses/UnexpectedError"}}}}}}
```
